// skeleton
#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <math.h>
#include "timing.h"
#include "likwid.h"
#include "divs.h"

int main(int argc, char** argv) {

  double wct_start,wct_end,cput_start,cput_end,frequency;
  int id,nt,k;
  int NITER;
  struct timespec sleeptime = {0, 10000000};
  double t = 0;

  if(argc!=2) {
    printf("Usage: %s <GHz>\n",argv[0]);
    exit(1);
  }
  frequency = atof(argv[1])*1e9;

  LIKWID_MARKER_INIT;
#pragma omp parallel
{
  LIKWID_MARKER_THREADINIT;
  LIKWID_MARKER_REGISTER("iter");
}

  NITER=1;
  do {
    // time measurement
    timing(&wct_start, &cput_start);

#pragma omp parallel private(k)
{
    for(k=0; k<NITER; ++k) {
      LIKWID_MARKER_START("iter");
      if(divsleep(200000) < 0.0)
	    exit(1);
      LIKWID_MARKER_STOP("iter");
    }
}
    timing(&wct_end, &cput_end);
    NITER = NITER*2;
  } while (wct_end-wct_start<0.2);

  NITER = NITER/2;

  printf(" %.6le \n",(wct_end-wct_start)/NITER*frequency);

  LIKWID_MARKER_CLOSE;
  
  return 0;
}
